<?php
require_once("../admin/user.php");

if (preg_match('/^(get_access_right|set_access_right|get_all_albums_public|set_access_right_for_albums)$/', $_POST['action'])) {
	csSYNOPhotoMisc::CheckAdminTimeOut();
}

if($_REQUEST['action'] == 'get_access_right' && isset($_REQUEST['uid'])) {
	echo SYNOPHOTO_ADMIN_GetUserAlbumData($_REQUEST['uid']);
} else if($_POST['action'] == 'get_access_right' && isset($_POST['sharename'])) {
	echo SYNOPHOTO_ADMIN_GetAlbumUserData($_POST['sharename']);
} else if($_POST['action'] == 'set_access_right' && isset($_POST['shareid'])) {
	SYNOPHOTO_ADMIN_AddAccessRightByShareid($_POST['shareid'], $_POST['add_user']);
	SYNOPHOTO_ADMIN_DeleteAccessRightByShareid($_POST['shareid'], $_POST['delete_user']);
	$result['success'] = true;
	echo json_encode($result);
} else if($_POST['action'] == 'set_access_right' && isset($_POST['uid'])) {
	SYNOPHOTO_ADMIN_AddAccessRightByUid($_POST['uid'], $_POST['add_album']);
	SYNOPHOTO_ADMIN_DeleteAccessRightByUid($_POST['uid'], $_POST['delete_album']);
	$result['success'] = true;
	echo json_encode($result);
} else if($_POST['action'] == 'get_all_albums_privilege') {
	echo SYNOPHOTO_ADMIN_GetAllAlbumsPrivilege();
} else if($_POST['action'] == 'set_access_right_for_albums') {
	echo SYNOPHOTO_ADMIN_SetAllAlbumsPrivilege($_POST['public_list'], $_POST['private_list'], $_POST['password_list']);
}

function SYNOPHOTO_ADMIN_DeleteAccessRightByUid($uid, $delete_albums)
{
	if ($uid == null || $uid == "" ||
		$delete_albums == null || $delete_albums == "") {
		return;
	}

	$query = "Delete from " . PHOTO_ACCESS_RIGHT_TABLE . " where userid = ? and shareid in (".$delete_albums.")";
	$sqlParam = array($uid);
	$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query, $sqlParam);

	$query = "Delete from " . PHOTO_UPLOAD_RIGHT_TABLE . " where userid = ? and shareid in (".$delete_albums.")";
	$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query, $sqlParam);
}

function SYNOPHOTO_ADMIN_DeleteAccessRightByUidAll($uid)
{
	$query = "Delete from " . PHOTO_ACCESS_RIGHT_TABLE . " where userid = ?";
	$sqlParam = array($uid);
	$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query, $sqlParam);

	$query = "Delete from " . PHOTO_UPLOAD_RIGHT_TABLE . " where userid = ?";
	$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query, $sqlParam);
}

function SYNOPHOTO_ADMIN_DeleteAccessRightByShareid($shareid, $delete_users)
{
	if ($shareid == null || $shareid == "" ||
		$delete_users == null || $delete_users == "") {
		return;
	}

	$query = "Delete from " . PHOTO_ACCESS_RIGHT_TABLE . " where userid in (".$delete_users.") and shareid =".$shareid;
	$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);
}

function SYNOPHOTO_ADMIN_AddAccessRightByUid($uid, $accessible_albums)
{
	if($uid == null || $uid == "" ||
		$accessible_albums == null || $accessible_albums == "") {
		return;
	}

	$arr = explode(",", $accessible_albums);

	foreach ($arr as $tok) {
		if($tok == "") {
			continue;
		}
		$date = date('Y-m-d H:i:s');
		$query = "Insert into " . PHOTO_ACCESS_RIGHT_TABLE . " (userid, shareid, create_time) ";
		$query = $query."Values (".$uid.", ".$tok.", '".$date."')";
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);
	}
}

function SYNOPHOTO_ADMIN_AddAccessRightByShareid($shareid, $accessible_users)
{
	if($shareid == null || $shareid == "" ||
		$accessible_users == null || $accessible_users == "") {
		return;
	}

	$arr = explode(",", $accessible_users);
	foreach ($arr as $tok) {
		if($tok == "") {
			continue;
		}
		$date = date('Y-m-d H:i:s');
		$query = "Insert into " . PHOTO_ACCESS_RIGHT_TABLE . " (userid, shareid, create_time) ";
		$query = $query."Values (".$tok.", ".$shareid.", '".$date."')";
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);
	}
}

function SYNOPHOTO_ADMIN_GetUserAlbumData($uid)
{
	$query = "Select * from photo_share where is_subdir = 'f' order by sharename asc";
	$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

	$list = array();
	while(($row = PHOTO_DB_FetchRow($db_result))) {
		$item = SYNOPHOTO_ADMIN_GetUserAlbumDataOneItem($row, $uid, null, 1);

		$escape = PHOTO_DB_GetEscape();
		$query = "Select * from photo_share where sharename like ? $escape order by sharename asc";
		$sqlParam = array(PHOTO_DB_EscapForLike($row[1]).'/%');
		$db_result_2 = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query, $sqlParam);

		$children = array();
		$children_id = array();
		while(($row_2 = PHOTO_DB_FetchRow($db_result_2))) {
			if ($row['password']) {
				$item['browse'] = '1';
			}
			$children[] = SYNOPHOTO_ADMIN_GetUserAlbumDataOneItem($row_2, $uid, $row[0], $item['browse']);
			$children_id[] = $row_2[0];
		}

		$item['child_id'] = json_encode($children_id);

		if(0 == count($children)) {
			$item['_is_leaf'] = true;
		}

		$list[] = $item;

		foreach ($children as $child) {
			$list[] = $child;
		}
	}

	$result['all'] = $list;
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_GetUserAlbumDataOneItem($row, $uid, $parent_id, $parent_status)
{
	$result['_id'] = $row[0];
	$result['_parent'] = $parent_id;
	$result['browse'] = 0;
	$result['browse_orig'] = 0;
	$result['upload'] = 0;
	$result['upload_orig'] = 0;

	if ($parent_id != null) { // is_subdir
		$result['name'] = htmlspecialchars(substr($row[1], strpos($row[1], "/") + 1), ENT_QUOTES);
		$result['_level'] = 2;
		$result['_lft'] = 2;
		$result['_is_leaf'] = true;
		$result['child_id'] = null;
	} else {
		$result['name'] = htmlspecialchars($row[1], ENT_QUOTES);
		$result['_level'] = 1;
		$result['_lft'] = 1;
		$result['_is_leaf'] = false;
	}
	if (PHOTO_DB_ConvertBool($row[4]) == 't') { // is_public

		$result['name'] = "(".__(photo_str_photoalbum_public2).") ".$result['name'];

		$result['public'] = 1;
		$result['browse'] = 1;
		$result['browse_orig'] = 1;

		if(0 == $parent_status) {
			$result['browse'] = 0;
			$result['browse_orig'] = 0;
			return $result;
		}
		$query = "Select * from " . PHOTO_UPLOAD_RIGHT_TABLE . " where shareid = ".$row[0]." and userid = ".$uid;
		$db_result_3 = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

		if(PHOTO_DB_FetchRow($db_result_3)) {
			$result['upload'] = 1;
			$result['upload_orig'] = 1;
		}
		return $result;
	}

	if ($row['password']) {
		$result['public'] = 2;
	}

	$query = "Select * from " . PHOTO_ACCESS_RIGHT_TABLE . " where shareid = ".$row[0]." and userid = ".$uid;
	$db_result_2 = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

	if (PHOTO_DB_FetchRow($db_result_2)) {
		$result['browse'] = 1;
		$result['browse_orig'] = 1;

		$query = "Select * from " . PHOTO_UPLOAD_RIGHT_TABLE . " where shareid = ".$row[0]." and userid = ".$uid;
		$db_result_3 = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

		if (PHOTO_DB_FetchRow($db_result_3)) {
			$result['upload'] = 1;
			$result['upload_orig'] = 1;
		}
	}
	return $result;
}

function SYNOPHOTO_ADMIN_GetAlbumUserData($sharename)
{
	$query = "Select * from photo_share where sharename = '" . PHOTO_DB_EscapeParam($sharename) . "'";
	$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);
	if ($row = PHOTO_DB_FetchRow($db_result)) {
    	$shareid = $row['shareid'];
    	$isPublic = ('t' == $row['public']);
	} else {
    	return;
	}

	$parentid = null;
	if (strstr($sharename, "/")) {
		$parent = substr($sharename, 0, strpos($sharename, "/"));
		$query = "Select * from photo_share where sharename = '".PHOTO_DB_EscapeParam($parent)."'";
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);
		$row = PHOTO_DB_FetchRow($db_result);
		if ('' == $row['password'] && PHOTO_DB_ConvertBool($row['public']) == 'f') {
			// For parent albunm be privated
			// Only users who have the permission of the parent album can be candidates of the second album.
			// So we must filter them out
			$parentid = $row['shareid'];
		}
	}

	$users = json_decode(SYNOPHOTO_ADMIN_GetAllUsersForAlbum(), true);
	$result['totalCount'] = $users['totalCount'];
	$result['all'] = array();

	for ($i = 0 ; $i < $users['totalCount'] ; $i++) {
		$result['all'][$i]['disabled'] = 0;
		if (null != $parentid) {
			$query = "Select * from " . PHOTO_ACCESS_RIGHT_TABLE . " where shareid = " . $parentid;
			$query .= " and userid = " . $users['all_users'][$i]['userid'];
			$db_result_parent = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

			// Only users who have the permission of the parent album can be candidates of the second album.
			if(false == ($row_parent = PHOTO_DB_FetchRow($db_result_parent))) {
				$result['all'][$i]['disabled'] = 1;
			}
		}

		$result['all'][$i]['userid'] = $users['all_users'][$i]['userid'];
		$result['all'][$i]['username'] = $users['all_users'][$i]['username'];
		$result['all'][$i]['description'] = $users['all_users'][$i]['description'];
		$query = "Select * from " . PHOTO_ACCESS_RIGHT_TABLE . " where shareid = " . $shareid;
		$query .= " and userid = " . $users['all_users'][$i]['userid'];
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

		$row = PHOTO_DB_FetchRow($db_result);
		if (($row != null || $isPublic) && (0 == $result['all'][$i]['disabled'])) {
			$result['all'][$i]['browse'] = 1;
			$result['all'][$i]['browse_orig'] = 1;
		} else {
			$result['all'][$i]['browse'] = 0;
			$result['all'][$i]['browse_orig'] = 0;
		}

		$query_2 = "Select * from " . PHOTO_UPLOAD_RIGHT_TABLE . " where shareid = " . $shareid;
		$query_2 .= " and userid = " . $users['all_users'][$i]['userid'];
		$db_result_2 = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query_2);

		$row_2 = PHOTO_DB_FetchRow($db_result_2);
		if($row_2 != null) {
			$result['all'][$i]['upload'] = 1;
			$result['all'][$i]['upload_orig'] = 1;
		} else {
			$result['all'][$i]['upload'] = 0;
			$result['all'][$i]['upload_orig'] = 0;
		}
	}
	return json_encode($result);
}


function SYNOPHOTO_ADMIN_GetUserAlbumPrivilegeOneItem($row, $parent_id)
{
	$item = array();
	$item['_parent'] = $parent_id;
	$item['_id'] = $row['shareid'];
	if ($parent_id) {
		$item['name'] = htmlspecialchars(substr($row['sharename'], strpos($row['sharename'], "/") + 1), ENT_QUOTES);
		$item['_level'] = 2;
		$item['_is_leaf'] = true;
	} else {
		$item['name'] = htmlspecialchars($row['sharename'], ENT_QUOTES);
		$item['_level'] = 1;
		$item['_is_leaf'] = false;
	}

	if (PHOTO_DB_ConvertBool($row['public']) == 't' && !$row['password']) {
       	$item['public'] = 1;
		$item['original'] = 'public';
	       $item['public_orig'] = 1;
    } else {
       	$item['public'] = 0;
		$item['public_orig'] = 0;
    }

	if ($row['password'] && '' != $row['password']) {
		$item['password_content'] = '＃＃＃＃＃＃＃＃';
		$item['password_content_orig'] = '＃＃＃＃＃＃＃＃';
		$item['password'] = 1;
		$item['original'] = 'password';
		$item['password_orig'] = 1;
	} else {
		$item['password_content'] = $row['password'];
		$item['password'] = 0;
		$item['password_orig'] = 0;
	}

	if (0 == $item['public'] && 0 == $item['password']) {
		$item['private'] = 1;
		$item['private_orig'] = 1;
		$item['original'] = 'private';
	} else {
		$item['private'] = 0;
		$item['private_orig'] = 0;
	}
	return $item;
}

function SYNOPHOTO_ADMIN_GetAllAlbumsPrivilege()
{
	$query = "Select * from photo_share where is_subdir = 'f' order by sharename asc";
	$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

	$list = array();
	while(($row = PHOTO_DB_FetchRow($db_result))) {
		$item = SYNOPHOTO_ADMIN_GetUserAlbumPrivilegeOneItem($row, null);

		$escape = PHOTO_DB_GetEscape();
		$query = "Select * from photo_share where sharename like ? $escape order by sharename asc";
		$sqlParam = array(PHOTO_DB_EscapForLike($row['sharename']).'/%');
		$db_result_2 = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query, $sqlParam);

		$children = array();
		$children_id = array();
		while(($row_2 = PHOTO_DB_FetchRow($db_result_2))) {
			$children[] = SYNOPHOTO_ADMIN_GetUserAlbumPrivilegeOneItem($row_2, $row['shareid']);
		}


		if(0 == count($children)) {
			$item['_is_leaf'] = true;
		}

		$list[] = $item;

		foreach ($children as $child) {
			$list[] = $child;
		}
	}

	$result['totalCount'] = count($list);
	$result['all'] = $list;
	$result['success'] = true;
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_SetAllAlbumsPrivilege($public_list, $private_list, $password_json)
{

	if($public_list != null && $public_list != "") {
		$query = "Update photo_share set public='t', password = '' where shareid in (".$public_list.")";
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

		$query = "Delete from " . PHOTO_ACCESS_RIGHT_TABLE . " where shareid in (".$public_list.")";
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

		$query = "Delete from " . PHOTO_UPLOAD_RIGHT_TABLE . " where shareid in (".$public_list.")";
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);
	}

	if($private_list != null && $private_list != "") {
		$query = "Update photo_share set public='f', password = '' where shareid in (".$private_list.")";
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

		$query = "Delete from " . PHOTO_UPLOAD_RIGHT_TABLE . " where shareid in (".$private_list.")";
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);
	}

	if($password_json != null && $password_json != "") {
		$passArray = json_decode($password_json, 1);
		$password_list = '';
		$tmpArray = Array();

		foreach ($passArray as $item) {
			$query = "Update photo_share set public='f', password = '" . md5($item['password']) . "' where shareid = " . $item['id'];
			$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);
			$tmpArray[] = $item['id'];
		}
		$password_list = join("," , $tmpArray);

		$query = "Delete from " . PHOTO_ACCESS_RIGHT_TABLE . " where shareid in (".$password_list.")";
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);

		$query = "Delete from " . PHOTO_UPLOAD_RIGHT_TABLE . " where shareid in (".$password_list.")";
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query);
	}

	$result['success'] = true;
	return json_encode($result);
}

function SYNOPHOTO_ADMIN_DeleteUploadPermissionByUid($uid, $delete_albums)
{
	if ($uid == null || $uid == "" ||
		$delete_albums == null || $delete_albums == "") {
		return;
	}

	$query = "Delete from " . PHOTO_UPLOAD_RIGHT_TABLE . " where userid = ? and shareid in (".$delete_albums.")";
	$sqlParam = array($uid);
	$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query, $sqlParam);
}

function SYNOPHOTO_ADMIN_AddUploadPermissionByUid($uid, $accessible_albums)
{
	if($uid == null || $uid == "" ||
		$accessible_albums == null || $accessible_albums == "") {
		return;
	}

	$arr = explode(",", $accessible_albums);

	foreach ($arr as $tok) {
		if($tok == "") {
			continue;
		}
		$date = date('Y-m-d H:i:s');
		$query = "Insert into " . PHOTO_UPLOAD_RIGHT_TABLE . " (userid, shareid, create_time) ";
		$query = $query."Values (?, ?, ?)";
		$sqlParam = array($uid, $tok, $date);
		$db_result = PHOTO_DB_Query($GLOBALS['dbconn_photo'], $query, $sqlParam);
	}
}
