<?php
require_once("include/syno_conf.php");

$mobileUAPattern = '/(iPhone|iPod|SymbianOS|Android|Windows CE|PalmOS|BlackBerry|Vodafone|Opera Mobi|Opera Mobi|UP\.Browser|AvantGo|EudoraWeb|PLink|Plucker|NetFront|Xiino|Blazer|WebPro|ProxiNet|Elaine)/i';
$userAgent = isSet($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '';
if (isSet($_GET['forceDesktop']) ||
	(isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['mobileUser']) && 'Desktop' == $_SESSION[SYNOPHOTO_ADMIN_USER]['mobileUser'])) {
	$_SESSION[SYNOPHOTO_ADMIN_USER]['mobileUser'] = 'Desktop';
} else if (preg_match($mobileUAPattern, $userAgent) ||
	isSet($_SERVER['HTTP_UA_OS']) || isSet($_SERVER['HTTP_X_WAP_PROFILE'])) {
	header('Location: '.SYNOPHOTO_URL_PREFIX.'/photo/m/');
	exit();
}

csSYNOPhotoDB::GetDBInstance()->SetSessionCache(true);
$currentUrl = csSYNOPhotoMisc::GetServerHost();
$currentUrl .= SYNOPHOTO_URL_PREFIX.'/photo/index.php';

$isDisplayAll = false;
if (isSet($_GET['display']) && $_GET['display'] == 'all') {
	$isDisplayAll = true;
}
$page = 1;
if (isSet($_GET['page']) && is_numeric($_GET['page'])) {
	$page = $_GET['page'];
}
$manage = null;
if (isSet($_GET['man']) && is_numeric($_GET['man'])) {
	$manage = $_GET['man'];
}

$dsmVersion = csSYNOPhotoMisc::GetDsmVersion();
$packageVersion = csSYNOPhotoMisc::GetPackageVersion();
$smarty->assign('DSM_VERSION', '?v='.$dsmVersion);
$smarty->assign('PACKAGE_VERSION', '?v='.$packageVersion);

$lang = $_SESSION[SYNOPHOTO_ADMIN_USER]['lang'];
$smarty->assign('LAN_PARAM', "ln=$lang");

$title =  htmlspecialchars(csSYNOPhotoDB::GetDBInstance()->GetConfig('photo', 'photo_page_title'));
if($title == NULL || $title == "") {
	$title = __(photo_str_ap_name);
}

$albumPerLoad = csSYNOPhotoDB::GetDBInstance()->GetConfig('album', 'num_one_page');
if (!$albumPerLoad) {
	$albumPerLoad = 40;
}
$manageActionStr = '';
$jsGlobalVars = 'var gAlbumCount=0; var gManageMode=null; var gIsAdmin=false;var gIsDisplayAll=false; var gCurrentPage=null;'.
				'var gAllowCopyFromDs=false; var gIsDemoMode = false;var gDisableShare = false; var gDisableRightButton = false; var gSelectList = "";';
$jsGlobalVars .= 'var unique="'.$_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['defCfg']['unique'].'";';
$jsGlobalVars .= 'var gSocialNetworkList = '.json_encode(SocialNetwork::ReadList()).';';

if ($manage != null && ($manage == 0 || $manage == 1) && isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'])) {
	$albumList = csSYNOPhotoBrowse::GetBrowseInstance()->GetAlbumList(($page - 1) * $albumPerLoad, $albumPerLoad, false);
	$jsGlobalVars .= 'gManageMode='.$manage.';';
	$totalPage = ceil($albumList['albumCount']/$albumPerLoad);
	$smarty->assign('PAGE_INDEX', $albumList['pageIndex']);
	$smarty->assign('TOTALPAGE', $totalPage);
	$smarty->assign('PAGE_URL', 'index.php?man='.$manage.'&');
	$jsGlobalVars .= "gTotalPage=$totalPage;";
	$jsGlobalVars .= "gCurrentPage=$page;";
	if ($manage == 1) {
		$manageActionStr = __(photo_str_deleteuser);
	} else {
		$manageActionStr = __(photo_str_man_album_move);
	}
	if (isSet($_SESSION[SYNOPHOTO_ADMIN_USER]['select_list'])) {
		$jsGlobalVars .= 'gSelectList="'.$_SESSION[SYNOPHOTO_ADMIN_USER]['select_list'].'";';
	}
} else if ($isDisplayAll) {
	$albumList = csSYNOPhotoBrowse::GetBrowseInstance()->GetAlbumListAll(true);
	$smarty->assign('IS_DISPLAY_ALL', true);
	$smarty->assign('PAGE_URL', 'index.php?');
	$jsGlobalVars .= 'gIsDisplayAll=true;';

} else {
	$albumList = csSYNOPhotoBrowse::GetBrowseInstance()->GetAlbumList(($page - 1) * $albumPerLoad, $albumPerLoad);
	$totalPage = ceil($albumList['albumCount']/$albumPerLoad);
	$smarty->assign('PAGE_URL', 'index.php?');
	$smarty->assign('PAGE_INDEX', $albumList['pageIndex']);
	$smarty->assign('TOTALPAGE', $totalPage);
	$jsGlobalVars .= "gTotalPage=$totalPage;";
	$jsGlobalVars .= "gCurrentPage=$page;";
}

$jsGlobalVars .= "gAlbumCount=".$albumList['albumCount'].";";

if (csSYNOPhotoDB::GetDBInstance()->GetConfig('photo', 'hide_search') == 'on') {
	$smarty->assign('IS_HIDE_SEARCH', true);
}

if(isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user'])) {
	$smarty->assign('IS_ADMIN', true);
	$jsGlobalVars .= 'gIsAdmin=true;';
	$jsGlobalVars .= "gSession='".session_id()."';";
	if ($_SESSION[SYNOPHOTO_ADMIN_USER]['use_dsm_account'] ||
		!isset($_SESSION[SYNOPHOTO_ADMIN_USER]['reg_syno_user'])) {
		$jsGlobalVars .= 'gAllowCopyFromDs = true;';
	}
}

$pageMainDesc = csSYNOPhotoDB::GetDBInstance()->GetConfig('main', 'main_page_desc');
if ((empty($pageMainDesc) && isset($_SESSION[SYNOPHOTO_ADMIN_USER]['admin_syno_user']))) {
	$pageMainDesc  = __(photo_str_add_description);
	$smarty->assign('ADD_DESC_CLASS', 'empty-desc');
} else {
	$pageMainDesc =  htmlspecialchars($pageMainDesc, ENT_QUOTES);
	$smarty->assign('ADD_DESC_CLASS', '');
}


$theme = $_SESSION[SYNOPHOTO_ADMIN_USER]['photo_config']['theme']['template'];
$mainPageImg = (empty($theme) || 'white' == $theme) ? SYNOPHOTO_IMG_DEFAULT_PERSONAL : SYNOPHOTO_IMG_DEFAULT_PERSONAL_BLACK;
if (file_exists(SYNOTHEME_PERSONAL_IMG_FILE)) {
	$img = @getImageSize(SYNOTHEME_PERSONAL_IMG_FILE);
	$mainPageImg = "include/synotheme.php?action=personal_img";
	$size['width'] = $img[0];
	$size['height'] = $img[1];
	$style = csSYNOPhotoMisc::GetOverFitCenterStyle($size, 54, 54);
}

$show_bkg_img = $_SESSION[SYNOPHOTO_ADMIN_USER]['photo_config']['theme']['show_bkg_img'];
if ($show_bkg_img && '1' == $show_bkg_img && file_exists(SYNOTHEME_BKG_SYNO_FILE)) {
	$smarty->assign('BKG_CHANGE',  @filemtime(SYNOTHEME_BKG_SYNO_FILE));
} else if ($show_bkg_img && '2' == $show_bkg_img && file_exists(SYNOTHEME_BKG_CUSTOM_FILE)) {
	$smarty->assign('BKG_CHANGE',  @filemtime(SYNOTHEME_BKG_CUSTOM_FILE));
} else if ($show_bkg_img && '3' == $show_bkg_img) {
	$smarty->assign('BKG_CHANGE',  '0');
} else {
	$smarty->assign('BKG_CHANGE',  rand());
}

if ('yes' == $_SESSION[SYNOPHOTO_ADMIN_USER]['system_config']['cfg']['enable_demomode']) {
	$jsGlobalVars .= 'gIsDemoMode = true;';
}
if (csSYNOPhotoDB::GetDBInstance()->GetConfig('photo', 'disable_share') == 'on') {
	$jsGlobalVars .= 'gDisableShare = true;';
}

if (csSYNOPhotoDB::GetDBInstance()->GetConfig('photo', 'disable_right_button') == 'on') {
	$jsGlobalVars .= 'gDisableRightButton = true;';
}

$jsGlobalVars .= 'var gAlbumDefAllowComment = false;';
if (csSYNOPhotoDB::GetDBInstance()->GetConfig('photo', 'album_def_allow_comment') == 'on') {
	$jsGlobalVars .= 'gAlbumDefAllowComment = true;';
}

if (csSYNOPhotoDB::GetDBInstance()->GetConfig('photo', 'show_album_hit') == 'on') {
	$smarty->assign('SHOW_ALBUM_HIT', true);
	$smarty->assign('DETAIL_ALBUM_CLASS', 'item-info-show-hit');
}

$pathLinkArray = csSYNOPhotoBrowse::GetBrowseInstance()->GetPathLinkArray("");

$smarty->assign('PHOTO_META_DESC', __(photo_str_meta_desc));
$smarty->assign('PHOTO_META_KEYWORD', __(photo_str_meta_keyword));
$smarty->assign('PHOTO_STATION_TITLE', $title);
$smarty->assign('WELCOME_TITLE', csSYNOPhotoMisc::GetWelcomeText());
$smarty->assign('HEADER_LINK_ARRAY', csSYNOPhotoMisc::GetTopHeaderLinkArray());
$smarty->assign('PATH_LINK_ARRAY', $pathLinkArray);
$smarty->assign('STR_ALBUMS', __(photo_str_albums));
$smarty->assign('STR_SHARE', __(photo_str_share));
$smarty->assign('STR_NEW_ALBUM', __(photo_str_add));
$smarty->assign('STR_MANAGEMENT', __(photo_str_man_manage));
$smarty->assign('STR_ACTION', $manageActionStr);
$smarty->assign('STR_CANCEL', __(photo_str_btnCancel));
$smarty->assign('STR_SELECT_ALL', __(photo_str_select_all));
$smarty->assign('STR_SELECT_PAGE_ALL', __(photo_str_select_page_all));
$smarty->assign('STR_DISPLAY_ALL', __(photo_str_display_all));
$smarty->assign('STR_DISPLAY_PAGE', __(photo_str_display_page));
$smarty->assign('STR_HITS', __(photo_str_hits));
$smarty->assign('SYNOTHEME_REQUEST_FILE', SYNOTHEME_REQUEST_FILE);

$smarty->assign('MAIN_PAGE_DESC', $pageMainDesc);
$smarty->assign('MAIN_IMG_SRC', $mainPageImg);
$smarty->assign('MAIN_IMG_STYLE', $style);

$smarty->assign('ALBUMS', $albumList['albums']);
$smarty->assign('ALBUM_COUNT', $albumList['albumCount']);
$smarty->assign('REAL_ALBUM_COUNT', count($albumList['albums']));//include virtual album
$smarty->assign('JS_GLOBAL_VARS', $jsGlobalVars);
$smarty->assign('SCRIPT_NEED_BY_ADMIN', $scriptForAdmin);
$smarty->assign('SCRIPT_NEED_BY_THEME', (isset($_GET['preview'])) ? 'var isPreview = 1;' : 'var isPreview = 0;');
$smarty->assign('PAGE_EMPTY_ICON_SRC', SYNOPHOTO_IMG_EMPTY_ALBUM_ICON);

if (0 < csSYNOPhotoMisc::GetUserType()) {
    $smarty->assign('PAGE_EMPTY_MSG', __(photo_str_login_inst_not_found));
} else {
    $msg = __(photo_str_login_inst_no_public);
    $msg = str_replace('{%1}', "<a href='javascript:onLogin(\"index.php\")'>".strtolower(__(photo_login))."</a>", $msg)."<br>";
    $smarty->assign('PAGE_EMPTY_MSG', $msg);
}

$smarty->assign('CURRENT_DESC',($pageMainDesc == __(photo_str_add_description)) ? '' : $pageMainDesc);
$smarty->assign('CURRENT_IMAGE_URL', $mainPageImg ? csSYNOPhotoMisc::GetServerHost().SYNOPHOTO_URL_PREFIX.'/photo/'.$mainPageImg : "");
$smarty->assign('CURRENT_URL', $currentUrl);

$impressumTemp = csSYNOPhotoDB::GetDBInstance()->GetConfig('photo', 'impressum_link');
if (null !== $impressumTemp && 0 < strlen($impressumTemp)) {
	$smarty->assign('IMPRESSUM_TEXT', htmlspecialchars($impressumTemp));
	$smarty->assign('IMPRESSUM_LINK', $impressumTemp);
}
$impressumTemp = csSYNOPhotoDB::GetDBInstance()->GetConfig('photo', 'impressum_text');
if (null !== $impressumTemp && 0 < strlen($impressumTemp)) {
	$smarty->assign('IMPRESSUM_TEXT', htmlspecialchars($impressumTemp));
}

$smarty->display('photo/index.tpl');

?>
