#!/bin/sh
# Copyright (c) 2000-2006 Synology Inc. All rights reserved.

SZF_THUMB_CREATE_QUEUE="/var/spool/thumb_create.queue"
SZF_THUMB_CREATE_QUEUE_TMP="/var/spool/thumb_create.queue_tmp"

case $1 in
   start)
      $0 stop
      echo "Removing all thumbnails of photo files..."
      
      find /var/services/photo/ -type d -name "*\.[j|J][p|P][g|G]" -exec rm -f \"{}/SYNOPHOTO:THUMB_B.jpg\" \"{}/SYNOPHOTO:THUMB_S.jpg\" \;
      find /var/services/photo/ -type d -name "*\.[b|B][m|M][p|P]" -exec rm -f \"{}/SYNOPHOTO:THUMB_B.jpg\" \"{}/SYNOPHOTO:THUMB_S.jpg\" \;

      su -l admin -c "/usr/syno/pgsql/bin/psql photo -c \"update photo_image set version = 0\"" > /dev/null 2>&1
            
      PHOTO_PATH=`ls -l /var/services/photo | awk -F "-> " '{print $2}'`

      if [ "$PHOTO_PATH" != "" ]; then
         if [ -d $PHOTO_PATH ]; then
            echo "Start recreating thumbnails ..."
            find $PHOTO_PATH -type d | grep -v @eaDir > $SZF_THUMB_CREATE_QUEUE_TMP
            mv $SZF_THUMB_CREATE_QUEUE_TMP $SZF_THUMB_CREATE_QUEUE
            kill -s SIGUSR1 `cat /var/run/synomkthumbd.pid`
         fi
      fi
      ;;
   stop)
      echo "Stop creating thumbnails ..."
      killall synothumb
      killall convert
      rm -f /var/run/synothumb*
      ;;	
   *)
      echo "Usage: $0 start|stop"
      ;;
esac

